<template>
    <q-dialog class="home">
        <q-card class="border-radius-50 q-pa-sm" style="width: 335px">
            <q-card-section class="row items-center row justify-center">
                <!-- Title -->
                <div class="col-12 items-center row justify-center">
                    <span
                        class="font-16 text-center helvetica-neue-medium"
                        no-caps
                    >
                        {{ $t('home.assignLabel') }}
                    </span>
                </div>

                <!-- Search Bar -->
                <div class="col-12 q-mt-sm">
                    <q-input
                        bottom-slots
                        v-model="search"
                        rounded
                        outlined
                        :dense="dense"
                        :placeholder="$t('home.searchLabels')"
                        bg-color="grey-3"
                        color="white"
                        :loading="state.loadingState"
                        debounce="500"
                        hide-bottom-space
                    ></q-input>
                </div>

                <!-- Label Selection (0-4 Selection) -->
                <div class="row justify-start items-center col-12">
                    <div
                        class="col-3 row justify-center"
                        v-for="(label, index) in state.labels"
                        :key="'label-' + index"
                        @click="select(label)"
                    >
                        <q-card
                            flat
                            bordered
                            class="label"
                            :style="{
                                backgroundColor: label.color
                            }"
                            :class="selectedLabel(label.id)"
                        >
                            <q-card-section class="q-pa-xs">
                                <div class="row justify-center items-center">
                                    <q-icon
                                        :name="label.icon"
                                        color="white"
                                        size="xs"
                                    ></q-icon>
                                </div>

                                <q-tooltip
                                    anchor="center right"
                                    self="center middle"
                                    content-class="“my-tooltip-content”"
                                >
                                    <div class="my-tooltip-content">
                                        {{ label.name }}
                                    </div>
                                </q-tooltip>
                            </q-card-section>
                        </q-card>
                    </div>

                    <div
                        class="col-12 text-center q-mt-sm"
                        v-if="tab == TabType.ONGOING"
                    >
                        <q-btn
                            color="primary"
                            class="border-radius-10"
                            padding="8px 18px"
                            unelevated
                            no-caps
                            @click="assignLabel()"
                        >
                            {{ $t('button.confirm') }}
                        </q-btn>
                    </div>
                </div>
            </q-card-section>
        </q-card>
    </q-dialog>
</template>

<script lang="ts">
import {
    defineComponent,
    ref,
    reactive,
    watch,
    computed,
    onMounted
} from 'vue';
import { useStore } from 'src/store';
import { TabType } from 'src/services/enums/TabType';

export default defineComponent({
    props: {
        convId: {
            type: String,
            required: true
        },
        tab: {
            type: String,
            required: true
        }
    },
    setup(props, { emit }) {
        const store = useStore();
        const search = ref('');
        const conversationState = store.state.conversation;

        const selectedBusinessId = computed(() => {
            return store.state.business.businessID;
        });

        let state = reactive({
            loadingState: ref(false),
            searchResults: ref(false),
            searchList: [] as any,
            selectedLabel: [] as any,
            labels: [] as any,
            permissions: computed(() => {
                return store.state.role.permissions;
            })
        });

        const getLabelList = async () => {
            if (state.permissions?.label?.list == true) {
                const result: any = await store.dispatch('label/getList');
                if (result.status == 200 && result.result.labels.length > 0) {
                    state.labels = result.result.labels;
                } else {
                    state.labels = [];
                }
            }
        };

        const assignLabel = () => {
            const body = {
                conversationId: props.convId,
                labelIds: state.selectedLabel
            };
            store.dispatch('conversation/assignLabel', body);
            updateValue(false);
        };

        const updateValue = (value: boolean) => {
            emit('update-assign', value);
            return value;
        };

        const getLabel = (text: string) => {
            state.labels = [];
            store.state.label.list.forEach((element: any) => {
                let result = element.name
                    .toLowerCase()
                    .indexOf(text.toLowerCase());
                if (result != -1) {
                    state.labels.push(element);
                } else if (!text) {
                    updateLabelList(store.state.label.list);
                }
            });
        };

        const select = (currentLabel: any) => {
            const index = state.selectedLabel.findIndex(
                (element: any) => element.id == currentLabel.id
            );
            if (index > -1) {
                state.selectedLabel.splice(index, 1);
            } else {
                if (state.selectedLabel.length < 4) {
                    state.selectedLabel.push(currentLabel);
                }
            }
        };

        const selectedLabel = (currentLabelID: string) => {
            const findIndex = state.selectedLabel.findIndex(
                (element: any) => element.id == currentLabelID
            );

            if (findIndex != -1) {
                return 'active';
            }
        };

        const getSavedLabelList = () => {
            state.selectedLabel = [];
            const conversation = conversationState.conversationsList.find(
                (conversation) => conversation.id === props.convId
            );

            conversation?.labels.forEach((label: any) => {
                state.selectedLabel.push(label);
            });
        };

        const updateLabelList = (result: any) => {
            state.labels = result;
        };

        onMounted(getLabelList);
        onMounted(getSavedLabelList);

        // Watch
        store.watch(
            () => props.convId,
            () => {
                getSavedLabelList();
            }
        );

        watch(selectedBusinessId, () => {
            if (selectedBusinessId.value) {
                getLabelList();
            }
        });

        watch(search, (currentValue) => {
            getLabel(currentValue);
        });

        return {
            state,
            search,
            dense: ref(true),
            updateValue,
            TabType,
            select,
            assignLabel,
            getLabelList,
            selectedLabel,
            getSavedLabelList
        };
    }
});
</script>
